%define vers		2.6.18
%define modpath		kernel/drivers/char/drm
%define atilibdir	%_libdir/ati-fglrx
%define x11dir		%_prefix/X11R6
%define x11libdir	%{x11dir}/%{_lib}
%define x11bindir	%{x11dir}/bin
%define __spec_install_post 	/usr/lib/rpm/brp-compress

Summary:   	ATI proprietary driver for ATI Radeon graphic cards
Name:      	ati-fglrx
Version:   	8.32.5
Release:   	2.6.18_1
License: 	Distributable
Group:          System
URL:		http://ati.amd.com/support/driver.html
Source0: 	https://a248.e.akamai.net/f/674/9206/0/www2.ati.com/drivers/linux/fglrx_6_8_0-8.32.5-1.i386.rpm
Source1:	fireglcontrol.desktop
Patch0:		%{name}-via_int_agpgart.patch
Patch1:		%{name}-panel_sources.diff
BuildRoot: 	%{_tmppath}/%{name}-buildroot
BuildRequires:	qt-devel Xorg-devel freetype-devel linux-headers = %{vers}

%description
This package contains the X11 driver, utilities and libraries needed for the
ATI proprietary driver ATI Radeon graphic cards.

This Package contains the kernel modules required for 3D acceleration with
the ATI proprietary driver ATI Radeon graphic cards.  This package is
built for kernel %{vers}.

Add  "/usr/lib/ati-fglrx"  to  '/etc/ld.so.conf'  if it is not already there.

%prep
%setup -c -T
unset CFLAGS
unset CXXFLAGS
mkdir fglrx
cd ./fglrx
rpm2cpio %{SOURCE0} | cpio --quiet --no-absolute-filenames -idmv 
cd ..
find fglrx/lib/modules/fglrx/build_mod/ fglrx/usr/share/doc  -type d -print0 | xargs -0 chmod 0755
find fglrx/lib/modules/fglrx/build_mod/ -type f -print0 | xargs -0 chmod 0644
find fglrx/usr/share/doc -type f -print0 | xargs -0 chmod 0644
%patch0 -p0
rm fglrx/%{x11bindir}/fireglcontrolpanel
mkdir -p fglrx_panel_sources
cd fglrx_panel_sources
tar -xzf ../fglrx/usr/src/ati/fglrx_panel_sources.tgz
%patch1 -p0
# we want to strip the binary
sed -i 's|STRIP = strip|STRIP = @echo strip is disabled for:|' Makefile
# correct name
sed -i 's|BASENAME =  fireglcontrol|BASENAME =  fireglcontrolpanel|' Makefile
# missing file in 8.20.8
#sed -i 's|#include "fglrx_pp_proto.h"||' R200_extensions.h
cd ..

%build
cd fglrx/lib/modules/fglrx/build_mod/
export AS_USER=y
export KERNEL_PATH="/usr/src/linux"
export CC="gcc"
bash make.sh verbose
cd ../../../../../

cd fglrx_panel_sources
make
cd ..

%install
rm -rf $RPM_BUILD_ROOT
install -D -p -m 0644 fglrx/lib/modules/fglrx/build_mod/2.6.x/fglrx.ko $RPM_BUILD_ROOT/lib/modules/%{vers}/%{modpath}/fglrx.ko
for file in $(cd fglrx &> /dev/null; find usr/ -type f | grep -v -e 'fireglcontrol.kdelnk$' -e 'fireglcontrol.desktop$' -e 'ati.xpm$' -e 'fglrx_panel_sources.tgz' -e 'fglrx_sample_source.tgz')
do
  if [[ "/${file}" = "%{x11libdir}/libGL.so.1.2" ]]
  then
    install -D -p -m 0755 fglrx/%{x11libdir}/libGL.so.1.2 $RPM_BUILD_ROOT%{atilibdir}/libGL.so.1.2
    ln -s libGL.so.1.2 $RPM_BUILD_ROOT%{atilibdir}/libGL.so.1
  elif grep -e '/bin/' -e '\.so$' -e '\.so\.[0-9]' <<<"${file}"
  then
    install -D -p -m 0755 fglrx/${file} $RPM_BUILD_ROOT/${file}
  else
    install -D -p -m 0644 fglrx/${file} $RPM_BUILD_ROOT/${file}
  fi
done
mkdir -p $RPM_BUILD_ROOT/%{_docdir}
mv $RPM_BUILD_ROOT/usr/share/doc/fglrx $RPM_BUILD_ROOT/%{_docdir}/%{name}-%{version}
ln -s libfglrx_gamma.so.1.0 $RPM_BUILD_ROOT/%{x11libdir}/libfglrx_gamma.so.1
install -D -p -m 0644 fglrx_panel_sources/ati.xpm $RPM_BUILD_ROOT/%{_datadir}/pixmaps/ati.xpm
install -D -p -m 0755 fglrx_panel_sources/fireglcontrolpanel $RPM_BUILD_ROOT/%{x11bindir}/fireglcontrolpanel

mkdir -p $RPM_BUILD_ROOT%{_datadir}/applications
install -m 644 %{SOURCE1} $RPM_BUILD_ROOT%{_datadir}/applications

mkdir -p $RPM_BUILD_ROOT/etc/ld.so.conf.d/
echo "%{atilibdir}" > $RPM_BUILD_ROOT/etc/ld.so.conf.d/ati-fglrx.conf

mv $RPM_BUILD_ROOT/usr/include/GL $RPM_BUILD_ROOT/usr/X11R6/include
rmdir $RPM_BUILD_ROOT/usr/include
rmdir $RPM_BUILD_ROOT/usr/share/doc

%clean
rm -rf $RPM_BUILD_ROOT

%post
/sbin/ldconfig
/sbin/depmod -a %{vers} 1>/dev/null 2>/dev/null

%postun
/sbin/ldconfig
/sbin/depmod -a 1>/dev/null 2>/dev/null

%files
%defattr(-,root,root,-)
/lib
/usr
